// ////////////////////////////////////////////////////
//
// StdView.cpp : implementation of the CStdView class
// Based on class COGLView : public CView
// Inspect COGLView for standard OpenGL initialization
//
////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Std.h"

#include "StdDoc.h"
#include "StdView.h"
#include "Bicycle.h"
#include "Robot.h"
#include "Math.h"
#include "Hat.h"
#include "Scenery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//float finger_krumming[] = {0.0f, 0.0f, 0.0f, 0.0f, 0.0f};


CBicycle bike;
CRobot *josef;
CScenery scenery;
//CHat hat;

float eyeX = 2.0f, eyeY = 2.0f, eyeZ = 2.0f;
float lookAtX = 0.0f, lookAtY = 0.0f, lookAtZ = 0.0f;
float robot_laar_vx[360];
float robot_legg_vx[360];
float adjust_bike_angle = -4.0f;
float sykkel_speed = 0.5f;
float robot_vx = 0.0f;
float robot_vy = 0.0f;
float robot_vz = 0.0f;


/////////////////////////////////////////////////////////
// You can put definitions, variables and helperfunctions
// here. Functions that does not rely on CStdView member
// variables or functions
//////////////////////////////////////////////
// helper to draw a box

void DrawBox()
{
	// draws the sides of a unit cube (0,0,0)-(1,1,1)

	glBegin(GL_POLYGON);//f1: front
		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);//f2: bottom
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f3:back
		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f4: top
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f5: left
		glNormal3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f6: right
		glNormal3f(0.0f,-1.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,1.0f,0.0f);
	glEnd();
}

//////////////////////////////////////////////////////////
// CStdView

IMPLEMENT_DYNCREATE(CStdView, COGLView)

BEGIN_MESSAGE_MAP(CStdView, COGLView)
	//{{AFX_MSG_MAP(CStdView)
	ON_COMMAND(ID_MATERIALER_BOKSER, OnMaterialerBokser)
	ON_COMMAND(ID_MATERIALER_BORD, OnMaterialerBord)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////
// CStdView construction/destruction

CStdView::CStdView()
{
	// initialize material, 
	// see menuhandlers and Drawscene
	m_BordMatIx=YELLOW_PLASTIC;
	m_KlossMatIx=BRASS;
	// initialize angles, see DrawScene
	m_xv=-60.0f;
	m_yv=0.0f;

	m_hRC=NULL;
	m_hDC=NULL;
};

CStdView::~CStdView()
{
	delete josef;
}

////////////////////////////////////////////////////////////
// CStdView diagnostics
// You should usually not touch these:
#ifdef _DEBUG
void CStdView::AssertValid() const
{COGLView::AssertValid();}
void CStdView::Dump(CDumpContext& dc) const
{COGLView::Dump(dc);}

CStdDoc* CStdView::GetDocument() // non-debug version is inline
{	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStdDoc)));
	return (CStdDoc*)m_pDocument;
}
#endif //_DEBUG

//////////////////////////////////////////////////////////////
// CStdView operations

void CStdView::DrawScene()
{
	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	// Set up for scene
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt( eyeX, eyeY, eyeZ,
			   lookAtX, lookAtY, lookAtZ,
			   0.0f, 0.0f, 1.0f);
	glRotatef(m_xv,1.0f,0.0f,0.0f);
	// rotate around z-axis 
	glRotatef(m_yv,0.0f,0.0f,1.0f);
	//glTranslatef(0.0f,10.0f,0.0f);
	// rotate around x-axis 
	//CMaterial::SetMaterial(GOLD);
	glPushMatrix();
		bike.transToGround();
		glTranslatef(-josef->x, -josef->y, -josef->z);
		scenery.drawScenery();
	glPopMatrix();
	glRotatef(robot_vz, 0.0f, 0.0f, 1.0f);
	glRotatef(robot_vx, 1.0f, 0.0f, 0.0f);
	//glRotatef(robot_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(adjust_bike_angle, 0.0f, 1.0f, 0.0f);

	glPushMatrix();
		bike.drawBike();
	glPopMatrix();
	bike.transToSeatRobot();
	glRotatef(-90.0f, 0.0f, 0.0f, 1.0f);
	glPushMatrix();
		//josef->moveL_LegTo(robot_laar_vx[0], robot_legg_vx[0]);//bike.seatToLPedalX(), bike.seatToLPedalY());
		//josef->moveR_LegTo(robot_laar_vx[180], robot_legg_vx[180]);//bike.seatToRPedalX(), bike.seatToRPedalY());
		josef->drawRobot();
	glPopMatrix();
	//hat.draw();
	//glRotatef(180.0f, 0.0f, 0.0f, 1.0f);
	//glTranslatef(1.0f, 0.0f, 0.0f);
	glFlush();
}

	//////////////////////////////////
	// bring construction in position

	// Based on:	default eye is at 0,0,0, 
	//				looking twds negative z-axis

	// move the construction down z
	/*glPushMatrix();
	

	//glTranslatef(0.0f, -2.0f, 0.0f);
	//glScalef(5.0f, 4.0f, 1.0f);
	//DrawBox();'
	/*glPushMatrix();
	//drawHand(20, false);
	drawTorso();
	glPopMatrix();
	glPopMatrix();

		//glScalef(0.5f, 0.1888f, 1.0f);

		//glTranslatef(-0.33f, 0.0f, -0.2f);
/*		glScalef(0.5f, 0.227f, 1.0f);
		for(int i = 0; i < 4; i++) {
			if(true)// i == 0) 
				drawFinger(-finger_krumming[i], 3);
			else
				drawFinger(0.0f, 3);
			glTranslatef(0.0f, 1.1f, 0.0f);			
		}
		
/*
	/////////////////////////////////////////////////
	// drawing the robot
	/////////////////////////////////////////////////
	// set precision for quadrics
	int n=20;
	////////////////////////////////////////////////
	// Draw base as disk - cylider - disk
	gluDisk(glpQ,0.0f,R1,n,n);
	gluCylinder(glpQ,R1,R1,L1,n,n);
	glTranslatef(0.0f,0.0f,L1);
	gluDisk(glpQ,0.0f,R1,n,n);
	////////////////////////////////////////////////
	// rotation angle F1, first variable
	glRotatef(F1,0.0f,0.0f,1.0f);//*****************
	////////////////////////////////////////////////
	////////////////////////////////////////////////
	// draw first, telescope-arm, second variable
	L3=F2-L2; //**********************************
	gluCylinder(glpQ,R2,R2,L2,n,n);
	glTranslatef(0.0f,0.0f,L2);
	gluDisk(glpQ,0.0f,R3,n,n);
	gluCylinder(glpQ,R3,R3,L3,n,n);
	glTranslatef(0.0f,0.0f,L3);
	gluDisk(glpQ,0.0f,R3,n,n);
	////////////////////////////////////////////////
	// rotation angle F3, third variable
	glRotatef(F3,0.0f,1.0f,0.0f);//*****************
	////////////////////////////////////////////////
	// draw last arm
	gluDisk(glpQ,0.0f,R4,n,n);
	gluCylinder(glpQ,R4,R4,L4,n,n);
	glTranslatef(0.0f,0.0f,L4);
	gluDisk(glpQ,0.0f,R4,n,n);

	/////////////////////////////////////////////////
	// end drawing the robot
	/////////////////////////////////////////////////
	gluDeleteQuadric(glpQ);
	
		/*glPushMatrix();
		glScalef(0.3f, 0.18f, 1.0f);
		glRotatef(-10.0f, 0.0f, 1.0f, 0.0f);
		DrawBox();
		glPopMatrix();
		
		glTranslatef(0.0f, 0.2f, 0.0f);
		glPushMatrix();
		glScalef(0.3f, 0.18f, 1.0f);
		DrawBox();
		glPopMatrix();

		glTranslatef(0.0f, 0.2f, 0.0f);
		glPushMatrix();
		glScalef(0.3f, 0.18f, 1.0f);
		DrawBox();
		glPopMatrix();

		glTranslatef(0.0f, 0.2f, 0.0f);
		glPushMatrix();
		glScalef(0.3f, 0.18f, 1.0f);
		DrawBox();
		glPopMatrix();

		glTranslatef(0.0f, 0.2f, 0.0f);
		glPushMatrix();
		glScalef(0.3f, 0.18f, 1.0f);
		DrawBox();
		glPopMatrix();
*/

	
	/////////////////////////////
	// Draw the construction
	
	// draw the "table"
	// set material for table
	/*CMaterial::SetMaterial(m_BordMatIx);
	glPushMatrix();
	glTranslatef(-3.5f,-1.0f,-0.11f);
	glScalef(7.0f,3.0f,0.1f);
	DrawBox();
	glPopMatrix();
	// set material for boxes
	CMaterial::SetMaterial(m_KlossMatIx);
	// the first box
	glPushMatrix();
	glTranslatef(-2.5f,0.0f,0.0f);
	glScalef(2.0f,1.0f,1.0f);
	DrawBox();
	glPopMatrix();
	// the second box
	glPushMatrix();
	glTranslatef(0.5f,0.0f,0.0f);
	glScalef(2.0f,1.0f,1.0f);
	DrawBox();
	glPopMatrix();
	// the box on top
	glTranslatef(-1.0f,0.0f,1.0f);
	glScalef(2.0f,1.0f,1.0f);
	DrawBox();
*/
	// End draw the construction
	/////////////////////////////


	// finnish drawing



void CStdView::InitializeRContext()
{
	// Here we set the attributes that will be constant
	// during the rendering contexts lifetime
	josef = new CRobot();
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    
	// prepare ligthsource
	GLfloat ambient[] = {0.2f,0.2f,0.2f,1.0f };
    GLfloat diffuse[] = {1.0f,1.0f,1.0f,1.0f };
    GLfloat position[] = {10.0f,0.0f,10.0f,0.0f };
	GLfloat lmodel_ambient[] = {0.8f,0.8f,0.8f,1.0f };
	//GLfloat direction[] = {-10.0f, 0.0f, 0.0f, };


    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_POSITION, position);
	//glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
	
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	// smooth the drawing
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DITHER);
	glEnable(GL_NORMALIZE);
	glEnable(GL_CULL_FACE);

    // set background to light gray
	glClearColor(0.2f, 0.2f, 1.0f, 0.0f);
	//glpQ=gluNewQuadric();

	/* Calculate leg positions. */
	calcLegPos();
	SetTimer(1, 100, NULL);
	josef->x = josef->y = josef->z = 0.0f;
}

void CStdView::SetPerspective(int cx,int cy)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluPerspective(50.0f, (GLdouble)cx/cy, 0.1f, 70.0f);
	glMatrixMode(GL_MODELVIEW);
}


void CStdView::OnMaterialerBokser() 
{
	CMaterial m;
	if(m.DoModal()==IDOK)
	{
		Invalidate(NULL);
		m_KlossMatIx=m.Get_Current_Index();
	}
}

void CStdView::OnMaterialerBord() 
{
	CMaterial m;
	if(m.DoModal()==IDOK)
	{
		Invalidate(NULL);
		m_BordMatIx=m.Get_Current_Index();
	}
}

void CStdView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// User has pressed left button.Make a note
	// of this and prepare for intuitive rotation of scene
	m_PLast=point;
	SetCapture();
	CView::OnLButtonDown(nFlags, point);
}

void CStdView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// free capture and terminate rotation
	ReleaseCapture();
	CView::OnLButtonUp(nFlags, point);
}

void CStdView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// if left button is down 
	if(nFlags && MK_LBUTTON)
	{	
		// and has moved a significant dist
		if((abs(m_PLast.x-point.x)>2)||(abs(m_PLast.y-point.y)>2))
		{
			// then we find an intuitive rot angle
			CRect R;
			GetClientRect(&R);
			
			m_yv+=90.0f*((GLfloat (point.x-m_PLast.x))/GLfloat (R.Width()));
			m_xv+=90.0f*((GLfloat (point.y-m_PLast.y))/GLfloat (R.Height()));
			
			// rememeber point and force immediate redraw 
			m_PLast=point;
			RedrawWindow();
		}
	}
}
/*
void CStdView::drawFinger(float width, float length, float k)
{
	GLUquadricObj *glpQ;
	glpQ=gluNewQuadric();

	float length_left = length;

	float part_length[] = {length/2, length/3, length/4};

	
	for(int i = 0; i < 3; i++) {
		glRotatef(k, 1.0f, 0.0f, 0.0f);
		gluCylinder(glpQ, width/2, width/2, part_length[i], 5, 5);
		glTranslatef(0.0f, 0.0f, part_length[i]);
	}
}
/*
	int n = 20;
	glPushMatrix();
	glRotatef(k, 0.0f, 1.0f, 0.0f);
	glRotatef(90, 0.0f, 1.0f, 0.0f);
	glScalef(1.0f, 2.0f, 1.0f);
	glTranslatef(0.0f, 0.0f, 0.0f);
	gluCylinder(glpQ, 0.5f, 0.5f, 0.5f, n, n);

	glPopMatrix();
}
/*
	float rel_length[] = {1.0f, 0.5f, 0.6f};
	float abs_length[] = {2.5f, 1.2f, 0.8f};

	glPushMatrix();
		glRotatef(k, 0.0f, 1.0f, 0.0f);
		glScalef(rel_length[depth], 1.0f, 1.0f);
		glTranslatef(-1.1f, 0.0f, 0.0f);
		if(depth != 0) 
			drawFinger(k, depth-1);
		DrawBox();
	glPopMatrix();
	
	
}

/*	glPushMatrix();
	float rel_length[] = {1.0f, 0.5f, 0.6f};
	float abs_length[] = {2.5f, 1.2f, 0.8f};
	glScalef(0.5f, 1.0f, 1.0f);
	for(int i = 0; i < 3; i++) {
			glRotatef(k, 0.0f, 1.0f, 0.0f);
			//glScalef(rel_length[i], 1.0f, 1.0f);
			glTranslatef(-1.1f, 0.0f, 0.0f);
			DrawBox();	
	}
	glPopMatrix();
	//glTranslatef(0.0f, 1.1f, 0.0f);			
}
*/
void CStdView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
		

	//COGLView::OnRButtonDown(nFlags, point);
	//finger_bevegelse_1();
	//m_xv = 0.0f;
	//m_yv = 0.0f;
	//RedrawWindow();
	//pedal_bevegelse_1();
	//sykkel_bevegelse1();
	//robot_bevegelse_5();
}



void CStdView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	COGLView::OnRButtonUp(nFlags, point);
}
/*
void CStdView::drawR_Hand()
{
	GLUquadricObj *glpQ;
	glpQ=gluNewQuadric();
	// Finger length relative to longest finger.
	float rel_finger_length[] = {0.6f, 0.8f, 1.0f, 0.85f, 1.0f};

	float width = 3.0f, length = 3.0f, height = 0.6f, finger_width = 0.6f, finger_space = 0.15f;

	glPushMatrix();
	glScalef(1.0f, height/length, 1.0f);
	gluCylinder(glpQ, width/2, width/2, length, 10, 10);
	//glTranslatef(-1.0f, -0.5f, 0.0f);
	//DrawBox();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-width/2+finger_width/2, 0.0f, length);
	for(int i = 0; i < 4; i++) {  // Fingers
		glPushMatrix();
		drawFinger(finger_width, length * rel_finger_length[i], r_finger_krumming[i]);
		glPopMatrix();
		glTranslatef(finger_width+finger_space, 0.0f, 0.0f);
	}

	// Thumb
	glTranslatef(0.0f, 0.0f, -length/2);
	glRotatef(-85.0f, 0.0f, 0.0f, 1.0f);
	glRotatef(20.0f, 0.0f, 1.0f, 0.0f);
	drawFinger(finger_width*1.5f, length*rel_finger_length[4], r_finger_krumming[4]);


	glPopMatrix();

/*	glTranslatef(-1.0f, 0.0f, -2.5f);
	gluCylinder(glpQ, 0.15f, 0.15f, 2.5f, 20, 20);
	glTranslatef(0.3f, 0.0f, 0.0f);
	gluCylinder(glpQ, 0.15f, 0.15f, 2.5f, 20, 20);
	glTranslatef(0.3f, 0.0f, 0.0f);
	gluCylinder(glpQ, 0.15f, 0.15f, 2.5f, 20, 20);
	
}
/*
void CStdView::drawL_Hand()
{
	GLUquadricObj *glpQ;
	glpQ=gluNewQuadric();
	// Finger length relative to longest finger.
	float rel_finger_length[] = {0.6f, 0.8f, 1.0f, 0.85f, 1.0f};

	float width = 3.0f, length = 3.0f, height = 0.6f, finger_width = 0.6f, finger_space = 0.15f;

	glPushMatrix();
	glScalef(1.0f, height/length, 1.0f);
	gluCylinder(glpQ, width/2, width/2, length, 10, 10);
	//glTranslatef(-1.0f, -0.5f, 0.0f);
	//DrawBox();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-width/2+finger_width/2, 0.0f, length);
	for(int i = 0; i < 4; i++) {  // Fingers
		glPushMatrix(); 
		drawFinger(finger_width, length * rel_finger_length[i], l_finger_krumming[i]);
		glPopMatrix();
		glTranslatef(finger_width+finger_space, 0.0f, 0.0f);
	}

	// Thumb
	glTranslatef(-width, 0.0f, -length/2);
	glRotatef(-85.0f, 0.0f, 0.0f, 1.0f);
	glRotatef(20.0f, 0.0f, 1.0f, 0.0f);
	drawFinger(finger_width*1.5f, length*rel_finger_length[4], -l_finger_krumming[4]);

	glPopMatrix();

/*	glTranslatef(-1.0f, 0.0f, -2.5f);
	gluCylinder(glpQ, 0.15f, 0.15f, 2.5f, 20, 20);
	glTranslatef(0.3f, 0.0f, 0.0f);
	gluCylinder(glpQ, 0.15f, 0.15f, 2.5f, 20, 20);
	glTranslatef(0.3f, 0.0f, 0.0f);
	gluCylinder(glpQ, 0.15f, 0.15f, 2.5f, 20, 20);
	
}
*/

void CStdView::finger_bevegelse_2()
{
	for(int i = 0; i < 100; i+=3) {
		if(i < 55) {
			if(i <= 15) {
				//r_finger_krumming[0] = (float) i*2;
			}
			if(i <= 25 && i > 10) {
				//r_finger_krumming[1] = (i-10.0f)*2;
			}
			if(i <= 35 && i > 20) {
				//r_finger_krumming[2] = (i-20.0f)*2;
			}
			if(i <= 45 && i > 30) {
				//r_finger_krumming[3] = (i-30.0f)*2;
			}
			if(i <= 55 && i > 40) {
				//r_finger_krumming[4] = (i-40.0f)*2;
			}
		}
		else {
			for(int j = 0; j < 5; j++);
				//r_finger_krumming[j] = (100-i)/55.f*15.0f;
		}
		RedrawWindow();
	}

}

void CStdView::finger_bevegelse_1()
{
	for(float i = 0.0f; i < 40.0f; i+=4.0f) {
		for(int j = 0; j < 5; j++)
			;//r_finger_krumming[j] = i*(1.0f-j/10.0f);
		RedrawWindow();
	}
	for(float i = 40.0f;i >= 0.0f; i -= 4.0f) {
		for(int j = 0; j < 5; j++)
			;//r_finger_krumming[j] = i*(1.0f-j/10.0f);
		RedrawWindow();
	}

}

void CStdView::finger_bevegelse_3()
{
	//finger_krumming = {4.0f, 3.0f, 6.0f, 7.0f, 3.0f};
	int steps = 3, inc = 2;
	for(int i = 0; i < steps; i++) {
		;//r_finger_krumming[3] +=inc;
		RedrawWindow();
	}
	for(int i = 0; i < steps; i++) {
		;//r_finger_krumming[3] -=inc;
		RedrawWindow();
	}

}
/*
void CStdView::drawR_Arm()
{
	//GLUquadricObj *glpQ;
	//glpQ=gluNewQuadric();
	glPushMatrix();

	glRotatef(r_overarm_vx, 1.0f, 0.0f, 0.0f),
	glRotatef(r_overarm_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(r_overarm_vz, 0.0f, 0.0f, 1.0f);
	gluCylinder(glpQ, 1.0f, 1.0f, 10.0f, 10, 10);

	glTranslatef(0.0f, 0.0f, 10.0f);
	glRotatef(r_arm_vx, 1.0f, 0.0f, 0.0f),
	glRotatef(r_arm_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(r_arm_vz, 0.0f, 0.0f, 1.0f);
	gluCylinder(glpQ, 1.0f, 1.0f, 10.0f, 10, 10);

	glTranslatef(0.0f, 0.0f, 10.0f);
	glRotatef(r_haandledd_vx, 1.0f, 0.0f, 0.0f);
	glRotatef(r_haandledd_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(r_haandledd_vz, 0.0f, 0.0f, 1.0f);

	drawR_Hand();
	glPopMatrix();
}

void CStdView::drawL_Arm()
{
	//GLUquadricObj *glpQ;
	//glpQ=gluNewQuadric();
	glPushMatrix();

	glRotatef(l_overarm_vx, 1.0f, 0.0f, 0.0f),
	glRotatef(l_overarm_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(l_overarm_vz, 0.0f, 0.0f, 1.0f);
	gluCylinder(glpQ, 1.0f, 1.0f, 10.0f, 10, 10);

	glTranslatef(0.0f, 0.0f, 10.0f);
	glRotatef(l_arm_vx, 1.0f, 0.0f, 0.0f),
	glRotatef(l_arm_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(l_arm_vz, 0.0f, 0.0f, 1.0f);
	gluCylinder(glpQ, 1.0f, 1.0f, 10.0f, 10, 10);

	glTranslatef(0.0f, 0.0f, 10.0f);
	glRotatef(l_haandledd_vx, 1.0f, 0.0f, 0.0f);
	glRotatef(l_haandledd_vy, 0.0f, 1.0f, 0.0f);
	glRotatef(l_haandledd_vz, 0.0f, 0.0f, 1.0f);

	drawL_Hand();
	glPopMatrix();
}


void CStdView::drawTorso()
{
	glPushMatrix();
	glScalef(1.0f, 0.4f, 1.0f);
	gluCylinder(glpQ, 5.0f, 5.0f, 10.0f, 10, 10);
	glPopMatrix();
}
*/
void CStdView::pedal_bevegelse_1()
{
	m_xv = m_yv = 0.0f;
	for(int i = 0; i < 30; i++) {
		bike.bevegPedal(10.0f, 1.0f);
		RedrawWindow();
	}
}

void CStdView::sykkel_bevegelse1()
{
	float inc;
	if(bike.getDirection() < 0)  // Styrer mot hoeyre og venstre annenhver gang.
		inc = 2.0f;
	else
		inc = -2.0f;

	for(int i = 0; i < 30; i++) {
		bike.bevegPedal(10.0f, -5.0f);
		bike.turnBike(inc);
		bike.rotateWheel(4.0f);
		RedrawWindow();
	}
}


void CStdView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if((nFlags&7) == 75)
		eyeX += 0.5f;
	COGLView::OnKeyDown(nChar, nRepCnt, nFlags);
	RedrawWindow();
}

void CStdView::robot_bevegelse_1()
{
	int i;
	
	for(i = 0; i < 20; i++) {
		josef->moveR_Leg(2, 2);
		josef->rot_body_x(1);
		RedrawWindow();
	}
	for(i = 0; i < 4; i++) {
		josef->moveR_Leg(-10, -10);
		RedrawWindow();
	}
	for(i = 0; i < 5; i++) {
		josef->moveR_Leg(-10, 0);
		RedrawWindow();
	}
	for(i = 0; i < 10; i++) {
		josef->moveR_Leg(5, 0);
		RedrawWindow();
	}
}

void CStdView::robot_bevegelse_2()
{
	int i, j, k;
	float laar = 4.0f, legg = 8.0f, r_oArm = 4.0f, r_uArm = -4.0f, l_oArm = 4.0f, l_uArm = -4.0f; 
	float dz = 0.003, dy = 0.04;
	float script[][10] = 
	{{laar, -laar, 0.0f, 0.0f, -dz, dy, r_oArm, 0.0f, -l_oArm, 0.0f},
	{-laar, laar, legg, 0.0f, dz, dy, -r_oArm, 0.0f, l_oArm, 0.0f},
	{-laar, laar, -legg, 0.0f, -dz, dy, -r_oArm, 0.0f, l_oArm, 0.0f},
	{laar, -laar, 0.0f, legg, dz, dy, r_oArm, 0.0f, -l_oArm, 0.0f},
	{laar, -laar, 0.0f, -legg, -dz, dy, r_oArm, 0.0f, -l_oArm, 0.0f},
	{-laar, laar, 0.0f, 0.0f, dz, dy, -r_oArm, 0.0f, l_oArm, 0.0f}};
	int start = 0, loop = 1, loops = 2, end = 5, dt = 8;
	
	i = start;
	for(j = 0; j < dt; j++) {
		josef->moveL_Leg(script[i][0], script[i][2]);
		josef->moveR_Leg(script[i][1], script[i][3]);
		josef->move_robot_z(script[i][4]);
		josef->move_robot_y(script[i][5]);
		josef->moveR_Arm(script[i][6], 0.0f, script[i][7], 0.0f);
		josef->moveL_Arm(script[i][8], 0.0f, script[i][9], 0.0f);
		RedrawWindow();
	}
	for(k = 0; k < loops; k++) 
		for(i = loop; i < end; i++) {
			for(j = 0; j < dt; j++) {
				josef->moveL_Leg(script[i][0], script[i][2]);
				josef->moveR_Leg(script[i][1], script[i][3]);
				josef->move_robot_z(script[i][4]);
				josef->move_robot_y(script[i][5]);
				josef->moveR_Arm(script[i][6], 0.0f, script[i][7], 0.0f);
				josef->moveL_Arm(script[i][8], 0.0f, script[i][9], 0.0f);
				RedrawWindow();
			}
		}
	i = end;
	for(j = 0; j < dt; j++) {
		josef->moveL_Leg(script[i][0], script[i][2]);
		josef->moveR_Leg(script[i][1], script[i][3]);
		josef->move_robot_z(script[i][4]);
		josef->move_robot_y(script[i][5]);
		josef->moveR_Arm(script[i][6], 0.0f, script[i][7], 0.0f);
		josef->moveL_Arm(script[i][8], 0.0f, script[i][9], 0.0f);
		RedrawWindow();
	}
}		

/*	for(i = 0; i < 8; i++) {
		josef->moveL_Leg(laar_move, 0);
		josef->moveR_Leg(-laar_move, 0);
		RedrawWindow();
	}
	for(j = 0; j < 4; j++) {
		for(i = 0; i < 8; i++) {
			josef->moveL_Leg(-laar_move,legg_move);
			josef->moveR_Leg(laar_move, 0);
			RedrawWindow();
		}	
		for(i = 0; i < 8; i++) {
			josef->moveL_Leg(-laar_move, -legg_move);
			josef->moveR_Leg(laar_move, 0);
			RedrawWindow();
		}
		for(i = 0; i < 8; i++) {
			josef->moveL_Leg(laar_move, 0);
			josef->moveR_Leg(-laar_move, legg_move);
			RedrawWindow();
		}
		for(i = 0; i < 8; i++) {
			josef->moveL_Leg(laar_move, 0);
			josef->moveR_Leg(-laar_move, -legg_move);
			RedrawWindow();
		}
	}
	for(i = 0; i < 8; i++) {
		josef->moveL_Leg(-laar_move, 0);
		josef->moveR_Leg(laar_move, 0);
		RedrawWindow();
	}^*/


void CStdView::robot_bevegelse_3()
{
	int i, j, k;
	float laar = -10, legg = 10; float dz = 0.003;
	float script[][5] = 
	{{laar, 0.0f, legg, 0.0f, 0.0f},
	{-laar, 0.0f, -legg, 0.0f, 0.0f},
	{0.0f, laar, 0.0f, legg, 0.0f},
	{0.0f, -laar, 0.0f, -legg, 0.0f}};
	int loop = 0, end = 4, loops = 2, dt = 8;
	
	for(k = 0; k < loops; k++) 
		for(i = loop; i < end; i++) {
			for(j = 0; j < dt; j++) {
				josef->moveL_Leg(script[i][0], script[i][2]);
				josef->moveR_Leg(script[i][1], script[i][3]);
				josef->move_robot_z(script[i][4]);
				RedrawWindow();
			}
		}
}

void CStdView::robot_bevegelse_4()
{
	int i, j;
	int head_dir = 1;

	m_xv = -15.0f;
	m_yv = 120.0f;
	josef->move_robot_y(-2.56f);

	robot_bevegelse_2();

/*	for(i = 0; i < 2; i++) {
		josef->rot_body_x(-1.0f);
		josef->rot_head_y(-2.0f);
		RedrawWindow();
	}
	josef->rot_body_x(-1.0f);
	for(i = 0; i < 5; i++) {
		for(j = 0; j < 4; j++) {
			josef->rotR_fot(-3.0f, 0.0f);
			josef->rot_head_y(2.0f*head_dir);
			RedrawWindow();
		}
		for(j = 0; j < 2; j++) {
			josef->rot_head_y(2.0f*head_dir);
			josef->rotR_fot(6.0f, 0.0f);
			RedrawWindow();
		}
		if(head_dir == 1)
			head_dir = -1;
		else
			head_dir = 1;
	}
	for(i = 0; i < 2; i++) {
		josef->rot_head_y(-2.0f);
		josef->rotR_fot(-3.0f, 0.0f);
		RedrawWindow();
	}
	josef->rot_head_y(-2.0f);
*/
	for(i = 0; i < 10; i++) {
		josef->rotHead(-12.0f);
		RedrawWindow();
	}
	for(i = 0; i < 3; i++) {
		josef->rotEyebrow(14.0f);
		RedrawWindow();
	}
	/*for(i = 0; i < 2; i++) {
		RedrawWindow();
	}*/
	for(i = 0; i < 10; i++) {
		josef->moveR_Arm(3.0f, -2.0f, -9.0f, -11.0f);
		josef->rotR_hand_x(-5.0f);
		josef->rotR_hand_y(-4.0f);
		RedrawWindow();
	}	
	
	josef->rotR_Arm(10.0f);
	
	for(i = 0; i < 3; i++) {
		josef->moveR_finger(0, -10.0f);
		josef->moveR_finger(1, -10.0f);
		josef->moveR_finger(2, -10.0f);
		RedrawWindow();
	}

	for(i = 0; i < 3; i++)  {
		for(j = 0; j < 3; j++)  {
			if(i < 1) 
				josef->rot_body_x(1.0f);
			josef->moveR_Arm(0.0f, 0.0f, 0.0f, 2.0f);
			josef->rotR_hand_y(5.0f);
			RedrawWindow();
		}
		for(j = 0; j < 3; j++)  {
			josef->moveR_Arm(0.0f, 0.0f, 0.0f, -2.0f);
			josef->rotR_hand_y(-5.0f);
			RedrawWindow();
		}
	}


	for(i = 0; i < 10; i++) {
		josef->moveR_Arm(-3.0f, 2.0f, 9.0f, 11.0f);
		josef->rotR_hand_x(5.0f);
		josef->rotR_hand_y(4.0f);
		josef->rotHead(12.0f);
		if(i >= 7) {
			josef->moveR_finger(0, 10.0f);
			josef->moveR_finger(1, 10.0f);
			josef->moveR_finger(2, 10.0f);
		}
		RedrawWindow();
	}
	for(i = 0; i < 3; i++) {
		josef->rotEyebrow(-14.0f);
		josef->rot_body_x(-1.0f);
		RedrawWindow();
	}
	josef->rotR_Arm(-0.0f);
/*	for(i = 0; i < 2; i++) {
		josef->rotR_fot(3.0f, 0.0f);
		josef->rot_head_y(2.0f);
	}*/
}

void CStdView::robot_bevegelse_5()
{
	int i, angle;
	double PI = 3.1415927;
	for(i = 0; i < 360; i+=10) {
		//josef->moveL_LegTo(0.0f+0.15f*cos(i*PI/180.0f), 0.69+0.15f*sin(i*PI/180.0f));
		bike.bevegPedal(30.0f, 0.0f);
		angle = bike.getPedalAngle();
		josef->moveL_LegTo(robot_laar_vx[angle%360], robot_legg_vx[angle%360]);
		josef->moveR_LegTo(robot_laar_vx[(angle+180)%360], robot_legg_vx[(angle+180)%360]);
		bike.rotateWheel(20.0f);
		RedrawWindow();
	}
}

void CStdView::calcLegPos()
{
	int i;
	float x, y;
	for(i = 0; i < 360; i++) {
		x = bike.calcPedalX(i);//bike.seatToLPedalX();
		y = bike.calcPedalY(i); //bike.seatToLPedalY();
		robot_laar_vx[i] = josef->calc_laar_angle(x, y);
		robot_legg_vx[i] = josef->calc_legg_angle(x, y);
		//bike.bevegPedal(1.0f, 0.0f);
	}
}

void CStdView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	static int time = 0;
	static int head_count = 0;
	static int move_count = 0;
	static float fall_speed = 2.0f;
	static float move_speed = 0.5f;
	static int counter = 0;

	time++;
	int t1 = 5, t2 = 20, t3 = 24, t4 = 40, t5 = 80, t6 = 83, t7 = 100, t8 = 108, t9 = 135;
	int t10 = 148, t11 = 151, t12 = 157, t13 = 178, t14 = 190, t15 = 200, t16 = 210;
	int t17 = 220, t18 = 227, t19 = 240, t20 = 260, t21 = 264, t22 = 269, t23 = 275;
	int t24 = 280, t25 = 285, t26 = 290;
	int steps = 4;
	static bool fly_opp = false;

	if(time < t1)
		sykkelFram();
	else if(time == t1) {
		m_yv = 0.0f;
		m_xv = 0.0f;
		eyeX = 7.0f;
		eyeY = 3.0f;
		sykkelFram();
	}
	else if(time < t2) {
		eyeX -= sykkel_speed;
		sykkelFram();	
	}
	else if(time == t2) {
		eyeY = 0.0f;
		eyeX = 3.0f;
		eyeZ = 1.5f;
		m_yv = 0.0f;
		m_xv = 0.0f;
		sykkelFram();
	}
	else if(time < t3) {
		sykkelFram();
	}
	else if(time == t3) {
		josef->rotEyebrow(7.0f);
		josef->rot_head_y(5.0f);
		sykkelFram();
	}
	else if(time < t4) {
		if(head_count == 1)
			josef->rot_head_y(-10.0f);
		else if(head_count == 3)
			josef->rot_head_y(10.0f);
		else if(head_count == 5)
			head_count = 0;
		head_count++;
		sykkelFram();
	}
	else if(time == t4) {
		eyeY = 0.0f;
		eyeX = -2.0f;
		eyeZ = 0.0f;
		josef->rot_head_y(-5.0f);
		m_yv = 0.0f;
		m_xv = 80.0f;
		sykkelFram();
	}
	else if(time < t5) {
		eyeX -= sykkel_speed;
		sykkelFram();
	}
	else if(time < t6) {
		eyeX = 115.0f;
		eyeZ = 2.0f;
		m_yv = 0.0f;
		m_xv = 0.0f;
		josef->x = 0.0f;
	}
	else if(time < t7) {
		lookAtZ = 0.5f;
		m_yv = 0.0f;
		m_xv = 10.0f;
		eyeX = 1.5f;
		eyeZ = 1.5f;
		eyeY = 0.0f;
		sykkel_speed = 1.0f;
		sykkelFram();
	}
	else if(time < t8) {
		lookAtX = 98.0f;
		lookAtY = 0.0f;
		josef->x = 0.0f;
		eyeX = 97.0f;
		eyeY = -5.0f;
		eyeZ = 2.0f;
		m_yv = 0.0f;
		m_xv = 0.0f;
	}
	else if(time < t9) {
		lookAtX = 0.0f;
		lookAtY = 0.0f;
		lookAtZ = -0.2f;
		eyeX = 0.0f;
		eyeY = 1.0f;
		eyeZ = 0.2f;
		m_xv = 0.0f;
		m_yv = 0.0f;
		sykkelFram();
	}
	else if(time == t9) {
		josef->x = 80.0f;
		eyeX = 26.0f;
		eyeY = -19.0f;
		eyeZ = 10.0f;
		m_xv = 0.0f;
		m_yv = 0.0f;
		lookAtX = 16.0f;
		lookAtY = 0.0f;
		lookAtZ = 0.0f;
	}
	else if(time < t10) {
		sykkelFram();
		eyeX -= sykkel_speed;
		lookAtX -= sykkel_speed;
	}
	else if(time == t10) {
		eyeX = 1.0f;
		eyeY = 0.0f;
		eyeZ = 0.8f;
		lookAtX = 0.0f;
		lookAtY = 0.0f;
		lookAtZ = 1.0f;		
		m_xv = 0.0f;
		m_yv = 0.0f;
		josef->rotEyebrow(-7.0f);
		/*josef->moveR_Arm(0.0f, 0.0f, 0.0f, 0.0f);
		josef->rotR_hand_z(180.0f);
		josef->rotR_hand_x(90.0f);
		josef->rotR_hand_y(20.0f);*/
		/*josef->rotL_hand_z(180.0f);
		josef->rotL_hand_x(90.0f);
		josef->rotL_hand_y(-20.0f);*/
		move_count = 0;
	}
	else if(time < t11) {
		sykkelFram();
		josef->rotEyebrow(6.0f);
		/*josef->moveR_Arm((-45.0f)*2/steps, 15.0f*2/steps, 
						(-90.0f)*2/steps, 10.0f*2/steps);*/
	}
	else if(time < t12) {
		sykkelFram();
	}
	else if(time == t12) {
		josef->x = 97.0f;
		eyeX = 3.0f;
		eyeY = -10.0f;
		eyeZ = 1.0f;
		lookAtX = 0.0f;
		lookAtY = 0.0f;
		lookAtZ = 1.0f;
		m_xv = 0.0f;
		sykkelFram();
		sykkel_speed = 0.0f;
	}
	else if(time < t13) {
		robot_vz += 8.0f;
		robot_vx -= 1.0f;
		josef->x += move_speed;
		move_speed *= 0.84f;
	}
	else if(time < t14) {
		bike.bevegPedal(120.0f, 0.0f);
		sykkelFram();
	}
	else if(time < t15) {
		bike.bz -= 1.0f;
	}
	else if(time == t15) {
		robot_vz = 180.0f;
		robot_vx = 0.0f;
		eyeX = 0.0f;
		eyeY = -1.0f;
		eyeZ = 0.9f;
		lookAtX = 0.0f;
		lookAtY = 0.0f;
		lookAtZ = 1.0f;
	}
	else if(time < t16) {
		josef->rotHead(11.0f);
	}
	else if(time < t17) {

	}
	else if(time < t18) {
		josef->z -= 1.0f;
		eyeZ += 1.0f;
		lookAtZ += 1.0f;
		//josef->moveHat_z(1.0f);
	}
	else if(time == t18) {
		bike.bz = -5.0f;
		eyeZ = -8.0f;
		lookAtZ = -8.0f;
		eyeY = 3.0f;
	}
	else if(time < t19) {
		josef->z -= 1.0f;
		eyeZ += 1.0f;
		lookAtZ += 1.0f;
	}
	else if(time == t19) {
		josef->x = 0.0f;
		josef->z = 40.0f;
		eyeZ = -8.0f;
		lookAtZ = 0.0f;
		eyeY = 5.0f;
	}
	else if(time < t20) {
		josef->z -= 1.0f;
		eyeZ += 1.0f;
	}
	else if(time == t20) {
		josef->z = 8.0;
		eyeZ= -7.9;
		eyeY = 0.01f;
	}
	else if(time < t21) {
		josef->z -= 1.0f;
		eyeZ += 1.0f;
	}
	else if(time < t22) {
		josef->z -= 1.0f;
		bike.bz -= 1.0f;
		eyeZ += 1.0f;
	}
	else if(time == t22) {
		josef->rotHead(-90.0f);
		bike.bz = 0.0f;
		josef->z = 0.0f;
		eyeY = 2.0f;
		eyeZ = 0.5f;
		lookAtZ = 0.8f;
	}
	else if(time < t23) {
		
	}
	else if(time == t23) {
		eyeY = 0.0f;
		eyeX = -2.0f;
	}
	else if(time < t24) {
		josef->rot_head_x(10.0f);
	}	
	else if(time < t25) {

	}
	else if(time < t26) {
		josef->rot_head_x(-10.0f);
	}
/*	else if(time == t26) {
		time = 0;
		robot_vz = robot_vy = robot_vx = 0.0f;
		eyeX = eyeY = eyeZ = 2.0f;
		adjust_bike_angle = -4.0f;
        sykkel_speed = 0.5f;
	}*/
	RedrawWindow();
	//bike.bevegPedal(1.0f, 0.0f);
}



void CStdView::sykkelFram()
{
	static int angle;
	double PI = 3.1415927;
	bike.bevegPedal(sykkel_speed*60.0f, 0.0f);
	angle = bike.getPedalAngle();
	josef->moveL_LegTo(robot_laar_vx[angle%360], robot_legg_vx[angle%360]);
	josef->moveR_LegTo(robot_laar_vx[(angle+180)%360], robot_legg_vx[(angle+180)%360]);
	bike.rotateWheel(20.0f);
	josef->x += sykkel_speed;

}
